#include<iostream>

using namespace std;

enum class BladStosu{ ePrzepelnienie, ePusty };

class ExcBladStos{};
class ExcPelny :public ExcBladStos{};
class ExcPusty :public ExcBladStos{};

template <class T>//, class TT, class TTT> 
class Stos
{
	T * stos;
	int max;
	int aktual;
public:
//	enum BladStosu{ePrzepelnienie, ePusty};
	Stos(int ile)
	{
		if (ile > 0)
		{
			max = ile;
			stos = new T[max];
			aktual = 0;
		}
		else
		{
			max = aktual = 0;
			stos = nullptr;
		}
	}
	~Stos()
	{
		delete[] stos;
		stos = nullptr;
		max = aktual = 0;
	}
	void Wstaw(const T& obiekt);
	T& Zdejmij();
};

template<class T> void Stos<T>::Wstaw(const T& obiekt)
{
	if (aktual<max)	stos[aktual++] = obiekt;
	//else throw 1;
	//else throw BladStosu::ePrzepelnienie;
	else throw ExcPelny();

}

template<class T> T& Stos<T>::Zdejmij()
{
	if (aktual>0) return stos[--aktual];
	//throw BladStosu::ePusty;
	throw ExcPusty();
}

int main()
{
	try
	{

		Stos<double> stosik(13);

		//stosik.Zdejmij();
		stosik.Wstaw(1.2);
		stosik.Wstaw(-2.3);
		stosik.Wstaw(4.5);
		stosik.Wstaw(11.5);
		try
		{
			for (;;)
				cout << stosik.Zdejmij() << endl;
		}
		catch (ExcPusty)
		{
		}
	}
	catch (int ex)
	{
		cerr << "(Chyba) Wystapil blad przepelnienia\n";
		cerr << ex << endl;
	}
	catch (BladStosu b)
	{
		cerr << "Wystapil wyjatek obslugi stosu\n";
		switch (b)
		{
		case BladStosu::ePusty:
			cerr << "Stos pusty\n";
			break; 
		case BladStosu::ePrzepelnienie:
			cerr << "Stos pelny\n";
			break;
		}
	}
	catch (ExcPelny)
	{
		cerr << "Cos za duzo elementow\n";
	}
	catch (ExcBladStos&)
	{
		cerr << "Blad stosu\n";
	}
	catch (...)
	{
		cerr << "Wystapil jakis wyjatek\n";
		//throw;
	}

	return 0;
}