#include "Ustawienia.h"
#ifdef WIRTUALNA_KLASA_PODSTAWOWA

/*
       A
      /  \
    BzA  CzA
     |    |
    DzB  EzC
      \  /
      FzDiE

*/

#include<iostream>
using namespace std;

class A
{
protected:
 int a;
public:
 A(int x){a=x;cout<<"K->A->a="<<a<<endl;}
};

class BzA:public virtual A
{
 int b;
public:
 BzA(int x):A(x){b=x+1;cout<<"K->BzA->b="<<b<<endl;}
};

class CzA:public virtual A
{
 int c;
public:
 CzA(int x):A(x){c=x+3;cout<<"K->CzA->c="<<c<<endl;}
};


class DzB:public BzA
{
 int d;
public:
 DzB(int x):BzA(x),A(x){d=x+2;cout<<"K->DzB->d="<<d<<endl;}
};

class EzC:public CzA
{
 int e;
public:
 EzC(int x):CzA(x),A(x){e=x+4;cout<<"K->EzC->e="<<e<<endl;}
};


class FzDiE:public DzB, public EzC
{
 int f;
public:
 FzDiE(int x):A(x),DzB(x),EzC(10*x){f=x;cout<<"K->FzDiE->f="<<f<<endl;}
 void W(){a=12;} //Brak wieloznacznosci
};

int main()
{
 FzDiE a(2);
 return 0;
}

#endif