#include<iostream>

using namespace std;

template<int ile=2>
void echo(const char* s)
{
	while (*s)
	{
//		cout << *s << *s;
		for (int i = 0; i < ile; ++i)cout << *s;
		++s;
	}

	cout << endl;
}

template <typename T> 
T Max(T a, T b)
{
	if (a > b) return a;
	return b;
}

#define POPRAWKA_NA_LANCUCHY_ZNAKOWE

#ifdef POPRAWKA_NA_LANCUCHY_ZNAKOWE
template<>
const char* Max<const char*>(const char* s1,const char* s2)
{
	if (strcmp(s1, s2) > 0) return s1;
	return s2;
}
#endif

int main()
{
	echo<2>("Proba");
	echo("Szablon");
	echo<3>("Koniec zajec");

	cout << Max(1, 2) << endl;
	cout << Max(1.2, -3.4) << endl;
	
	//cout << Max(-1.2, -1) << endl;
	cout << Max<char>(-2.2, 65.9) << endl; 

	cout << Max<double>(-1.2, -1) << endl;

	const char*s1 = "Ela1";
	const char*s2 = "Ala1";
	const char*s3 = "Ala2";
	const char*s4 = "Ela2";

	cout << "Proba dla lancuchow znakowych:\n";
	cout << Max(s1, s2) << endl;
	cout << Max(s3, s4) << endl;
	cout << "Powinno byc:\n" << s1 << endl << s4 << endl;

	return 0;
}