#include "Ustawienia.h"
#ifndef WIRTUALNA_KLASA_PODSTAWOWA

/*
     A    A
     |    |
    BzA  CzA
     |    |
    DzB  EzC
      \  /
      FzDiE

*/
#include<iostream>
using namespace std;

class A
{
protected:
 int a;
public:
 A(int x){a=x;cout<<"K->A->a="<<a<<endl;}
};

class BzA:public A
{
 int b;
public:
 BzA(int x):A(x){b=x+1;cout<<"K->BzA->b="<<b<<endl;}
};

class CzA:public A
{
 int c;
public:
 CzA(int x):A(x){c=x+3;cout<<"K->CzA->c="<<c<<endl;}
};


class DzB:public BzA
{
 int d;
public:
 DzB(int x):BzA(x){d=x+2;cout<<"K->DzB->d="<<d<<endl;}
};

class EzC:public CzA
{
 int e;
public:
 EzC(int x):CzA(x){e=x+4;cout<<"K->EzC->e="<<e<<endl;}
};


class FzDiE:public DzB, public EzC
{
 int f;
public:
 FzDiE(int x):EzC(x * 10), DzB(x)/*DzB(x),EzC(x*10)*/{f=x;cout<<"K->FzDiE->f="<<f<<endl;}
 //void W() { EzC::a = 1; } //Poszlaka
 void W() { CzA::a = 1; } //Poszlaka
 //void W() { EzC::CzA::A::a = 1; } //
 //void W() { a = 1; } //Bd wieloznacznoci
 
 //void W() { a() = 1; } //Bd wieloznacznoci wyeliminowany
protected:
 int& a() { return EzC::a; }
 int& _a() { return DzB::a; }
};

int main()
{
  FzDiE a(2);
  return 0;
}

#endif

/*
     A{a}
     |
    BzA   A{a}
     |    |
    DzB  EzC
      \  /
      FzDiE <- a nie jest wieloznaczne -> z gazi EzC

*/
